require "import"
import "com.androlua.LuaDialog"
import "android.content.Context"
import "android.os.Vibrator"
import "android.content.Intent"
import "android.net.Uri"
import "android.widget.*"
import "android.view.*"

local context = activity or service
local vibrator = context.getSystemService(Context.VIBRATOR_SERVICE)

-- عنوان ووصف
local dialogTitle = "إهداء من يوسف البياتي لجميع شيعة علي"
local dialogDescription = [[
هذه إهداء لجميع إخواننا الشيعة في جميع أنحاء العالم.
يمكنك من خلال هذه الإضافة المفيدة تحميل جميع القصائد الحسينية التي ترغب بها لجميع الرواديد الكبار.
استمع وشارك الأجر.
]]

-- بيانات القصيدة
local links = {"قصيدة - لبيك يا حسين"}
local audioUrls = {"https://youtu.be/iDl53HsSC_Y?si=kE5TnG4jkE4n3oRi"}

-- تصميم الواجهة
layout = {
  LinearLayout,
  orientation = "vertical",
  padding = "16dp",
  {
    TextView,
    text = dialogTitle,
    textSize = "22sp",
    gravity = "center",
    textColor = 0xFF880000,
  },
  {
    TextView,
    text = dialogDescription,
    textSize = "18sp",
    gravity = "center",
    padding = "12dp",
  },
  {
    ListView,
    id = "listView",
    layout_width = "match",
    layout_height = "wrap",
  },
  {
    Button,
    text = "إغلاق",
    onClick = function()
      dlg.dismiss()
      vibrator.vibrate(100)
    end,
    layout_gravity = "center",
  },
}

-- إنشاء مربع الحوار
dlg = LuaDialog(service)
dlg.setTitle("القصائد الحسينية")
dlg.setCancelable(true)
dlg.View = loadlayout(layout)

-- إعداد القائمة
local items = {}
for i = 1, #links do
  table.insert(items, links[i])
end
listView.setAdapter(ArrayAdapter(context, android.R.layout.simple_list_item_1, String(items)))

-- عند الضغط على عنصر
listView.onItemClick = function(parent, view, position, id)
  vibrator.vibrate(100)
  local name = links[position + 1]
  local audio = audioUrls[position + 1]

  -- حوار بسيط فيه فقط زر "استماع"
  local subLayout = {
    LinearLayout,
    orientation = "vertical",
    padding = "16dp",
    {
      TextView,
      text = "اضغط استماع للانتقال إلى صفحة القصيدة",
      textSize = "18sp",
      gravity = "center",
    },
    {
      Button,
      text = "استماع",
      onClick = function()
        openInYouTube(audio)
        subDlg.dismiss()
        dlg.dismiss()
      end,
    },
  }

  subDlg = LuaDialog(service)
  subDlg.setTitle(name)
  subDlg.View = loadlayout(subLayout)
  subDlg.show()
end

-- فتح الرابط في تطبيق YouTube
function openInYouTube(url)
  local intent = Intent(Intent.ACTION_VIEW)
  intent.setData(Uri.parse(url))
  intent.setPackage("com.google.android.youtube") -- فتحه بتطبيق YouTube
  pcall(function()
    context.startActivity(intent)
  end)
  if service and service.asyncSpeak then
    service.asyncSpeak("تم فتح الرابط في يوتيوب")
  end
end

dlg.show()

function onKeyDown(code, event)
  if code == KeyEvent.KEYCODE_BACK then
    dlg.dismiss()
    return true
  end
end

return true
